/*
 * Monster.cpp
 *
 *  Created on: 15/apr/2013
 *      Author: bertini
 */

#include <iostream>
#include "Monster.h"
#include "Dice.h"

Monster::Monster(int hp, int a, int d, int t, int f) :
		Character(hp, a, d), treasure(t), fear(f) {
	name = "";
	std::cout << "Monster constructor" << std::endl;
}

Monster::~Monster() {
	std::cout << "Clean Monster from game map" << std::endl;
}

void Monster::move(int x, int y) {
	posX = x;
	posY = y;
	if (treasure > 100)
		std::cout << "Monster moving slowly..." << std::endl;
	std::cout << "Monster moving to: " << x << " - " << y << std::endl;
}

int Monster::fight(Character& enemy) {
	Dice aDice(4);
	int hit = aDice.throwDice();
	int damage = 0;
	if (hit > enemy.getLevel()) {
		if (weapon == 0)
			return damage;
		damage = weapon->useWeapon();
		if (damage > enemy.getArmor()) {
			if (fear > 6)
				damage++;
			enemy.setHp( enemy.getHp() - damage);
			std::cout << "enemy hit: " << damage << std::endl;
		} else {
			std::cout << "did not pass through enemy armor !" << std::endl;
		}
	} else
		std::cout << "hit miss !" << std::endl;

	return damage;
}
